--- adjust command-line arguments
for i = 2, #arg - 1 do
  if arg[i]:sub(1, 1) == "-" then
    arg[i] = "-"..arg[i]
  end
end

-- assume the last argument is the path
local src = table.remove(arg)
src = src:gsub("\\", "/")
local last = ""
local path = {}
for s in src:gmatch("([^/]+)") do
  s = last..s
  last = s.."/"
  table.insert(path, last)
end

-- look for main.lua and "love.update"
local main
for i = #path - 1, 1, -1 do
  local m = path[i].."main.lua"
  local f = io.open(m, "r")
  if f then
    local all = f:read("*all")
    f:close()
    if all:find("love.update", 1, true) then
      main = path[i]
      break
    end
  end
end

-- look for love.exe
local base
for i = #path - 1, 1, -1 do
  local e = path[i].."love.exe"
  local f = io.open(e, "r")
  if f then
    f:close()
    base = path[i]
    break
  end
end

-- execute if possible
assert(main, src)
base = base or love.filesystem.getSourceBaseDirectory()
local exe = base.."/love.exe"
arg[1] = string.format("%q", main)
local args = table.concat(arg, " ")
local cmd = string.format('start "" %q %s', exe, args)
os.execute(cmd)
os.exit()